//broderi-slave
//redFrik 2011 gnu gpl v2

//barebone arduino pro8 with 3v battery, 8mhz chrystal.  program the mega168 with...
//avrdude -v -p m168 -b 115200 -P /dev/tty.PL2303-000013FA -c stk500v2 -U flash:w:borderiSlave.cpp.hex -U lfuse:w:0xE2:m -U hfuse:w:0xDF:m

//mirf library http://arduino.cc/playground/InterfacingWithHardware/Nrf24L01
//lsm303 library https://github.com/ryantm/LSM303DLH
//Narcoleptic library http://code.google.com/p/narcoleptic/

//outgoing wireless protocol: slavindex, axh, ayh, azh, mxh, myh, mzh, axl, ayl, azl, mxl, myl, mzl, 0, 0, 0

#include <Wire.h>
#include <LSM303DLH.h>
#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>
#include <Narcoleptic.h>

#define SLAVEINDEX 12				//12= ann, 13= fredrik
#define UPDATERATE 20

#define ACC_ADDRESS      (0x30 >> 1)
#define MAG_ADDRESS      (0x3C >> 1)
#define OUT_X_L_A        (0x28)
#define OUT_X_H_M        (0x03)

uint8_t tx_addr[5]= {20, 21, 22, 23, 24};
uint8_t rx_addr[5]= {13, 11, 12, 13, SLAVEINDEX};
uint8_t data[16]= {SLAVEINDEX, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 0, 0, 0};  //payload is 16 to match master

LSM303DLH compass;

void setup() {
  
  //--mirf setup
  Mirf.cePin= 8;               //pin 14 on mega168
  Mirf.csnPin= 9;              //pin 15 on mega168
  Mirf.spi= &MirfHardwareSpi;
  Mirf.init();
  Mirf.setRADDR(rx_addr);
  Mirf.setTADDR(tx_addr);
  Mirf.payload= sizeof(data);
  Mirf.channel= 3;
  Mirf.config();
  
  //--lsm303 setup
  Wire.begin();
  compass.enable();
}

void loop() {
  
  Wire.beginTransmission(ACC_ADDRESS);
  Wire.send(OUT_X_L_A | (1<<7));
  Wire.endTransmission();
  Wire.requestFrom(ACC_ADDRESS, 6);
  while (Wire.available()<6);
  data[7]= Wire.receive();
  data[1]= Wire.receive();
  data[8]= Wire.receive();
  data[2]= Wire.receive();
  data[9]= Wire.receive();
  data[3]= Wire.receive();
  Wire.beginTransmission(MAG_ADDRESS);
  Wire.send(OUT_X_H_M);
  Wire.endTransmission();
  Wire.requestFrom(MAG_ADDRESS, 6);
  while (Wire.available()<6);
  data[4]= Wire.receive();
  data[10]= Wire.receive();
  data[5]= Wire.receive();
  data[11]= Wire.receive();
  data[6]= Wire.receive();
  data[12]= Wire.receive();
  
  Mirf.send(data);
  while(Mirf.isSending()) {}
  
  Narcoleptic.delay(UPDATERATE);
}

